<template lang="pug">
div
    v-hover(
        v-slot:default="{ hover }"
    )
        v-card.my-8(
            :elevation="hover ? 12 : 2"
        )
            v-card-title {{ contextType }}
            v-card-text
                v-data-table(
                    :headers="headers"
                    :items="context.data"
                    :server-items-length="context.pages"
                    :items-per-page="10"
                    :loading="loading"
                    class="elevation-0"
                    v-model="selected"
                    @update:page="changePage($event)"
                    show-select
                    single-select
                )
                div.float-left.w-100.d-flex
                    v-btn(
                        :elevation="hover ? 12 : 2"
                        color="warning"
                        @click="deleteContext('deposit')"
                    ) Delete Context
                    v-btn.mx-auto(
                        :elevation="hover ? 12 : 2"
                        color="success"
                        @click="$emit('view-context', { selected: selected, type: contextType })"
                    ) View PDF
                    v-btn(
                        :elevation="hover ? 12 : 2"
                        color="success"
                        @click="$emit('new-context', contextType)"
                    ) New {{ contextType }}
    v-dialog(
      v-model="areYouSure"
    )
      v-card
        v-card-title Are You Sure?
        v-card-text Deleting a Context removes all associated Data and
          b cannot be undone!
          div.d-flex.mt-3
            v-btn(
              color="success"
              @click="areYouSure = false"
            ) No! Don't Delete!
            v-btn.ml-auto(
              color="warning"
              @click="confirmDelete"
            ) I'm Sure.
</template>

<script>
import { mapActions } from "vuex";

export default {
    name: "context-card",
    props: {
        headers: {
            required: true,
            type: Array
        },
        context: {
            required: true,
            type: Object
        },
        contextType: {
            required: true,
            type: String
        }
    },
    data() {
        return {
            areYouSure: false,
            loading: false,
            selected: [],
            page: 1
        };
    },
    methods: {
        ...mapActions({
            deleteACoffin: "coffin/deleteACoffin",
            fetchAllCoffin: "coffin/fetchAllCoffin",
            deleteACut: "cut/deleteACut",
            fetchAllCut: "cut/fetchAllCut",
            deleteADeposit: "deposit/deleteADeposit",
            fetchAllDeposit: "deposit/fetchAllDeposit",
            deleteAMasonry: "masonry/deleteAMasonry",
            fetchAllMasonry: "masonry/fetchAllMasonry",
            deleteASkeleton: "skeleton/deleteASkeleton",
            fetchAllSkeleton: "skeleton/fetchAllSkeleton",
            deleteATimber: "timber/deleteATimber",
            fetchAllTimber: "timber/fetchAllTimber"
        }),
        deleteContext() {
            if (this.selected.length === 0) {
                this.notification = `No ${
                    this.contextType
                }s have been selected`;
            } else {
                this.deleteUrl = this.selected[0].links.self;
                this.areYouSure = true;
                this.selected = [];
            }
        },
        confirmDelete() {
            let deleteContext;
            let fetchContext;
            if (this.contextType === "Coffins") {
                deleteContext = this.deleteACoffin;
                fetchContext = this.fetchAllCoffin;
            } else if (this.contextType === "Cuts") {
                deleteContext = this.deleteACut;
                fetchContext = this.fetchAllCut;
            } else if (this.contextType === "Deposits") {
                deleteContext = this.deleteADeposit;
                fetchContext = this.fetchAllDeposit;
            } else if (this.contextType === "Masonry") {
                deleteContext = this.deleteAMasonry;
                fetchContext = this.fetchAllMasonry;
            } else if (this.contextType === "Skeletons") {
                deleteContext = this.deleteASkeleton;
                fetchContext = this.fetchAllSkeleton;
            } else if (this.contextType === "Timbers") {
                deleteContext = this.deleteATimber;
                fetchContext = this.fetchAllTimber;
            } else {
                throw new Error("Unknown Context Type");
            }

            if (this.deleteUrl) {
                deleteContext({ url: this.deleteUrl }).then(() => {
                    fetchContext({ url: this.context.links.self });
                });
                this.areYouSure = false;
                this.deleteUrl = null;
            } else {
                this.notification =
                    "There was a problem deleting your context!";
                this.$sentry.captureMessage(
                    "Attempted to delete a context but there was no deleteUrl"
                );
                this.areYouSure = false;
                this.deleteUrl = null;
            }
        },
        changePage(e) {
            this.loading = true;
            let url;
            if (e > this.page) {
                url = this.context.links.next;
            } else if (e < this.pages) {
                url = this.context.links.previous;
            }
            this.pages = e;
            if (url) {
                this.$store
                    .dispatch("getContextsFromServer", {
                        url,
                        type: this.contextType
                    })
                    .then(() => {
                        this.loading = false;
                    });
            }
        }
    }
};
</script>

<style scoped>
.w-100 {
    width: 100%;
}
</style>
